//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  DeepPink
#property indicator_color3  LimeGreen
#property indicator_color4  DeepPink

//
//
//
//
//

extern ENUM_APPLIED_PRICE Price = 0;
extern double Length          = 10;
extern double Phase           = 0;
extern bool   Double          = true;
extern int    AtrLength       = 3; 
extern double Kv              = 2;  
extern double MoneyRisk       = 1; 
extern bool   ShowStop        = true;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertNotify     = false;
extern string soundfile       = "alert2.wav";
extern string note7           = "Arrow Type";
extern string note8           = "0=default,1=Thick,2=Thin,3=Hollow";
extern string note9           = "4=Round,5=Fractal,6=Diagonal Thin";
extern string note10          = "7=Diagonal Thick,8=Diagonal Hollow";
extern string note11          = "9=Thumb,10=Finger";
extern int    ArrowType       = 2;
extern int    arrowSize       = 2;


//
//
//
//
//

double UpLine[];
double DnLine[]; 
double CrossUp[];
double CrossDn[];
double smax[];
double smin[];
double trend[];

//
//
//
//
//

int init()
{
   switch(ArrowType)
   {
      case 0  : int arrowUp = 119; int arrowDn = 119; break;
      case 1  :     arrowUp = 233;     arrowDn = 234; break;
      case 2  :     arrowUp = 225;     arrowDn = 226; break;
      case 3  :     arrowUp = 241;     arrowDn = 242; break;
      case 4  :     arrowUp = 221;     arrowDn = 222; break;
      case 5  :     arrowUp = 217;     arrowDn = 218; break;
      case 6  :     arrowUp = 228;     arrowDn = 230; break;
      case 7  :     arrowUp = 236;     arrowDn = 238; break;
      case 8  :     arrowUp = 246;     arrowDn = 248; break;
      case 9  :     arrowUp =  67;     arrowDn =  68; break;
      case 10 :     arrowUp =  71;     arrowDn =  72; break;
   } 
      IndicatorBuffers(7);
      SetIndexBuffer(0,CrossUp); SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,arrowUp);
      SetIndexBuffer(1,CrossDn); SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,arrowDn);
      SetIndexBuffer(2,UpLine);  
      SetIndexBuffer(3,DnLine);  
      SetIndexBuffer(4,smax);
      SetIndexBuffer(5,smin);
      SetIndexBuffer(6,trend);
      
      if(ShowStop)
      {
        SetIndexStyle(2,DRAW_LINE);
        SetIndexStyle(3,DRAW_LINE);
      }
      else
      {
        SetIndexStyle(2,DRAW_NONE);
        SetIndexStyle(3,DRAW_NONE);
      }
          
      IndicatorShortName("Volty Channel Stop");
return(0);
}
   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   { 
   
         if(Price==2 || Price==3)
         {
           double bprice = iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i),Length,Phase,Double,i, 0);
           double sprice = iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW, i),Length,Phase,Double,i,20);
         }
         else
         {
           bprice = iDSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,Phase,Double,i, 0);
           sprice = iDSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,Phase,Double,i,20);
         }
         smin[i]    = sprice - Kv * iATR(NULL,0,AtrLength,i); 
	      smax[i]    = bprice + Kv * iATR(NULL,0,AtrLength,i);
         UpLine[i]  = EMPTY_VALUE;
         DnLine[i]  = EMPTY_VALUE;
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1]; 
   
         //
         //
         //
         //
         //
         
	      if (bprice > smax[i+1]) trend[i] =  1;
         if (sprice < smin[i+1]) trend[i] = -1;
	      if (trend[i] > 0 && smin[i] < smin[i+1]) smin[i] = smin[i+1];
	      if (trend[i] < 0 && smax[i] > smax[i+1]) smax[i] = smax[i+1];
         if (trend[i] == 1)
            {  
               UpLine[i] = smin[i] - (MoneyRisk - 1) * iATR(NULL,0,AtrLength,i); if (trend[i+1]!= 1) CrossUp[i] = UpLine[i];
            }
         if (trend[i] ==-1)
            {  
               DnLine[i] = smax[i] + (MoneyRisk - 1) * iATR(NULL,0,AtrLength,i); if (trend[i+1]!=-1) CrossDn[i] = DnLine[i];
            }
      }
      
      //
      //
      //
      //
      //
              
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
         
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert("uptrend");
        else  doAlert("downtrend");       
  }
return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Volty Stop ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Volty Stop "),message);
             if (alertNotify)   SendNotification(message);
             if (alertsSound)   PlaySound(soundfile);
      }
}


//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double tKv  = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - tKv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - tKv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}